package ru.dbotthepony.mc.otm.capability.matter;

import net.minecraft.MethodsReturnNonnullByDefault;
import ru.dbotthepony.mc.otm.core.ImpreciseFraction;

import javax.annotation.ParametersAreNonnullByDefault;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public interface IMatterHandler {
	enum MatterDirection {
		RECEIVE, // consumer
		EXTRACT, // producer
		BIDIRECTIONAL // storage
	}

	ImpreciseFraction getStoredMatter();
	ImpreciseFraction getMaxStoredMatter();

	ImpreciseFraction receiveMatterOuter(ImpreciseFraction howMuch, boolean simulate);
	ImpreciseFraction receiveMatterInner(ImpreciseFraction howMuch, boolean simulate);

	ImpreciseFraction extractMatterOuter(ImpreciseFraction howMuch, boolean simulate);
	ImpreciseFraction extractMatterInner(ImpreciseFraction howMuch, boolean simulate);

	MatterDirection getDirection();

	default ImpreciseFraction getMissingMatter() {
		return getMaxStoredMatter().minus(getStoredMatter());
	}
}
